"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.stripEvents = exports.prepareEvents = void 0;

var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _constants = require("../constants");

var prepareEvents = function prepareEvents(events, context) {
  var timestamp = Date.now() + 60 * 1000;
  var order = 0;
  var aggregateVersionsMap = new Map();
  return events.map(function (testEvent) {
    var _extends2;

    var aggregateId = testEvent.aggregateId != null ? testEvent.aggregateId : context == null ? void 0 : context.aggregateId;
    var aggregateVersion = aggregateVersionsMap.has(aggregateId) ? aggregateVersionsMap.get(aggregateId) + 1 : 1;
    var event = (0, _extends3["default"])({}, testEvent, {
      aggregateId: aggregateId,
      aggregateVersion: aggregateVersion,
      timestamp: timestamp++,
      payload: (0, _extends3["default"])({}, testEvent.payload, (_extends2 = {}, _extends2[_constants.reservedEventOrderField] = order++, _extends2))
    });
    aggregateVersionsMap.set(aggregateId, aggregateVersion);
    return event;
  });
};

exports.prepareEvents = prepareEvents;

var stripEvents = function stripEvents(events) {
  return events.sort(function (a, b) {
    return a.payload[_constants.reservedEventOrderField] - b.payload[_constants.reservedEventOrderField];
  }).map(function (event) {
    return (0, _extends3["default"])({}, event, {
      payload: (0, _extends3["default"])({}, (0, _lodash["default"])(event.payload, _constants.reservedEventOrderField))
    });
  });
};

exports.stripEvents = stripEvents;
//# sourceMappingURL=events-utils.js.map